<DELETEWIRE 
"DELETE WIRE

Deletes wires, vias, sections of wiring, or wiring from a set of nets.


Syntax

D*ELETE W*IRE {[optionsForNextWires] whatToDelete}...;

Note: If you use optionsForNextWires, you must specify it before whatToDelete.

optionsForNextWires = [
[DR*AW 	
| ER*ASE 
{L*AYER layer | D*ETAIL | G*LOBAL 			
| S*CORE | R*GRID | GG*RID 			
| P*INEXTRA | GS*EGEXTRA} ] 		
[SN*AP | NOS*NAP] 		
[DRC | NOD*RC] 		
[K*EEPGLOBAL | NOK*EEPGLOBAL] 		
[SP*LIT | NOSP*LIT] ]...
whatToDelete = 
{ {N*ET nets | ALLN*ETS} 
[NOB*ACKUP] 
[S*PECIALONLY | R*EGULARONLY 		
| A*NTENNAS | AL*L] 	
| [S*ECTION] pick}
pick = 
[ptOnWire | ptOnVia]


Arguments

DRAW, ERASE
Sets the graphics display of layers, routing type, score, grids, and highlights. The DRAW and ERASE options operate during the command in a pseudo-nested fashion (without DONE). After DELETE WIRE runs, the graphics appear as specified by Draw.* environmental variables.

[SNAP | NOSNAP]
Modifies the Snap.RGrid variable for the next picks, to BOTH or NONE, until DONE restores the variable to the original value. These options only apply to picks following the SPLIT option.

[DRC | NODRC]
Whether to invoke incremental VERIFY GEOMETRY at each pick. Default: true

[KEEPGLOBAL | NOKEEPGLOBAL]
 Whether to keep global routing for deleted wires. Default: KEEPGLOBAL. In some cases when KEEPGLOBAL is selected, DELETE WIRE keeps vias needed to connect to LAYERED global wiring.

[SPLIT | NOSPLIT]
When you use SPLIT with multiple picks, DELETE WIRE removes the wiring from the first to the last points, breaking the wire if these points are in the middle of a wire. Remains defined for a sequence of picks until redefined. Default: NOSPLIT

NET netID
Selects the net. For the ALL, REGULAR, SPECIAL, and ANTENNA options, you can specify multiple nets. If you specify multiple nets and then select a wiring option (pt, SECTION, SPLIT), only that net is edited. Selecting a net highlights the net and filters out subsequent picks that are not on that net.

ALLNETS
Same as NET * but runs quicker, because the command does not perform object lookup and highlighting.

NOBACKUP
This specifies a faster version of the REGULAR, SPECIAL, ANTENNAS, and ALL options, which does not support backup. If you type BACKUP after deletion, the edit cannot be undone. Typically, you use NOBACKUP only when specifying a large number of nets.

SPECIALONLY, REGULARONLY
Deletes all special or regular wiring for nets.

ANTENNAS
Deletes antennas in nets. For special wire antennas, the command only deletes one via, wire, or portion of a wire per antenna. You might need to run the command several times to remove complex special wire antennas.

ALL
Forces all wiring to be deleted. If specified, it deletes the wiring before DONE so you have the chance to BACKUP.

SECTION
For the next pick on regular wiring, deletes wiring in both directions until the first Steiner point, pin, or special wire. A pick on a pin or special wire is rejected. Multiple sections of the same net can be deleted in the same command if you specify SECTION before each pick.

pick
You can make successive picks for any points on regular wires, and DELETE WIRE finds a path between the points. For points on different wire types or special wires, the selected points must be on the same wire (that is, using SPLIT). Otherwise, each pick is treated independently. The wire is wire is deleted, but not the path between the picks. A single pick (with NOSPLIT) can delete the entire wire selected. Vias no longer needed are deleted also.

ptOnWire
Deletes the selected wire or point on the wire.

ptOnVia
Deletes the selected via.


Description

DELETE WIRE removes wires, vias, sections of wiring, or wiring from a set of nets. You can select any net, or regular and special wires and vias on any layer. 

DELETE WIRE pt deletes an individual wire. Multiple picks delete multiple wires. If the wiring is regular, it also remove the wiring between consecutive picks. 

You can also specify the net using the NET option. Once you specify the net, DELETE WIRE filters out wiring on any other nets during subsequent picks.

Instead of removing entire wires, the SPLIT option deletes exactly to the specified (snapped) point. In this case, the first pick specifies the first split point but does not actually delete any wiring. The next pick deletes wiring between it and the previous point, and so on. For special wiring, DELETE WIRE does not recognize paths between points; SPLIT points must be on the same wire for the path between them to be deleted.

If you use the SECTION option in regular wiring, DELETE WIRE can remove an entire section of wiring between pins or Steiner points with a single pick. 

Several DELETE WIRE options can operate on multiple nets (nets can be selected by using wild cards for names). You can delete all the regular wiring, all special wiring, all wiring of either type, or all antennas. Note that when you remove special wiring, DELETE WIRE also removes connections in regular wiring from the special wiring to the first pin or Steiner point in the regular wiring.

Modify.Code

You cannot delete wires and vias with a Modify.Code attribute of COVER (unless Allow.EC is true). You can delete wires and vias with a Modify.Code attribute of FREE or FIXED. Wires that are added by automatic routing tools are FREE. Wires added using ADD WIRE are FIXED and cannot be modified by SROUTE or FROUTE. Use CHANGE WIRE to change a wire or via, or use CHANGE NET to change the Modify.Code of all wires and vias in the net. 

For regular wiring, note that changing an individual wire's Modify.Code can also change adjacent wires in the same global route area (from GCell to GCell). In addition, if some wiring in a path between Steiner points is FIXED, GROUTE and FROUTE will likely not modify any wiring in that path.

GROUTE and FROUTE

ADD and DELETE WIRE are typically used in conjunction with GROUTE NET and FROUTE NET to automatically complete any missing connections in the net. ADD and DELETE WIRE support antennas and loops in regular wiring (as well as special wiring); regular wiring is never converted to special wiring. 

GROUTE and FROUTE support partial preroutes of any type. They might not entirely use pre-existing antennas, so although the net is completely wired, partial antennas can remain after FROUTE. Such antennas can be removed using DELETE WIRE ANTENNAS.

Loops in Regular Wiring

ADD WIRE warns you if you create a loop in regular wiring. However, you must be cautious in handling antennas. If you create a loop and stop the wiring at the loop, GROUTE, FROUTE, and DELETE WIRE see the wiring topology as an antenna rather than a loop because they see no connection. In this case, DELETE WIRE ANTENNAS removes the antenna and the loop. 

In general, INPUT DEF can read regular wiring loops, but might not reproduce the topology in the exact same way. INPUT DEF can break the wires in different places than they were originally (it tends to break the wires at the loop crossover point). Geometrically, the wiring produced by INPUT DEF remains the same.

Global Routing After DELETE WIRE 

DELETE WIRE of regular wiring can keep or discard the global routing, at your choice. In default mode (KEEPGLOBAL), the deleted detailed wires will be replaced with global routes representing the missing connection. FROUTE NET can be used directly to reroute that part of the net. Unneeded vias are removed by DELETE WIRE when wires are deleted; in some cases, DELETE WIRE KEEPGLOBAL leaves vias which are needed to connect to the global routes, which are layered.

If global wiring is discarded (NOKEEPGLOBAL) you must run GROUTE NET prior to FROUTE, to re-global route the missing connection.

Global routing is highlighted, but not otherwise drawn, using lines on the global-routing grid (between centers of GCells, on the GGrid). Optionally use DRAW GSEGEXTRA, or set Highlight.Net.Gsegs.Extra to true, to in addition draw a highlight line from the end of each global route (at the center of a GCell) to the point on detailed wiring it connects, if any. Such lines are not highlighted for global route connections to pins. 

VERIFY 

With the design rule check (DRC) option, DELETE WIRE invokes incremental geometry verification at each pick. (You can control the VERIFY GEOMETRY checks with the Verify.* environmental variables.) When making incremental checks, DELETE WIRE both removes and generates dynamic infos with each pick (and restores them on backup). Even if a pick generates new DRC infos, you can continue the edit.

With DRC off, DELETE WIRE does not invoke incremental VERIFY GEOMETRY. However, if Wire.Mark.NeedsDRC is true, the edited areas are marked with a special type of visible needs verification infos. Then, separately running VERIFY GEOMETRY SEARCHMODE verifies only the edited areas.

To avoid all verification during editing, you can set DRC off (NODRC or Wire.DRC to false), and set Wire.Mark.NeedsDRC to false. In this case, no infos are created or modified during edits.

DELETE WIRE does not update existing VERIFY CONNECTIVITY infos, but marks the net as needing verification this is not a visible info. Then VERIFY CONNECTIVITY SEARCHMODE only verifies the edited nets, and properly updates the infos.

Snapping Picks to the Routing Grid

When using SPLIT, the pick location is used to split the wire. DELETE WIRE typically snaps your pick to enforce grid wiring as much as possible. The manner that DELETE WIRE uses to snap to the routing grid is the same as for ADD WIRE. See the ``Snapping Picks to the Routing Grid'' section of the ADD WIRE description.

Display and Help

DELETE WIRE highlights the net being edited in the artwork window. If the net does not have more pins than the value of Wire.Highlight.Net.MaxPins, it is also highlighted in the context window. This highlight is erased by PAN and REFRESH, but is restored when you select the next point.

On a graphics platform with a fixed size message window, resize the message window to include 4 to 5 lines of messages while you are editing wiring. Otherwise, important messages can scroll off.

If you need help remembering options, use DESCRIBE VARIABLE WIRE.* and DESCRIBE COMMAND ADD and DELETE. Also, ``?'' during the ADD and DELETE WIRE commands gives you context- sensitive help.


Environmental Variables

Snap.RGrid 
STRING - {Grid | HalfGrid | Both | None} - Default: Both - NOVICE 
Controls how coordinates are snapped to grid. Grid selects points on the vertices of the routing grid. HalfGrid (and Both) selects points at the centers of the rectangles formed by the routing grid in addition to those on the grid. None disables grid snapping.

SnapRadius.<PtOnVia, PtOnWire> 
STRING - {Small | Medium | Large} - Default: Small - NOVICE
Determines how near the cursor must be to the given type of object to select the object.

SnapRadius.Small 
INTEGER [0, 1000000000] - Default: 100 - NOVICE
Sets the value of a Small snap radius.

Wire.Delete.NoBackUp 
BOOLEAN - Default: false - NOVICE 
If true, speeds DELETE WIRE performance, but backup does not restore wires.

Wire.DRC 
BOOLEAN - Default: true - NOVICE 
Whether ADD WIRE and DELETE WIRE commands automatically invoke VERIFY GEOMETRY in incremental mode with each user pick. Verify.* variables affect VERIFY GEOMETRY as usual.

Wire.DRC.CoverMacro.Check 
BOOLEAN - Default: false - NOVICE 
Whether DELETE WIRE checks against features in any cover macro. 

Wire.Highlight.Net.MaxPins 
INTEGER [1, 1000000000] - Default: 20 - NOVICE 
Controls net highlighting in the context window. When you pick a wire, the net is shown highlighted in the context window if it does not have more than this number of pins.

Wire.Keep.Global 
BOOLEAN - Default: true - NOVICE 
Whether DELETE WIRE keeps the global wiring for deleted wires.

Wire.Mark.NeedsDRC 
BOOLEAN - Default: false - NOVICE 
Whether to create ``Needs to be verified'' regions for VERIFY GEOMETRY SEARCHMODE if DRC is false. 

Wire.Preferred.Directions 
BOOLEAN - Default: true - NOVICE 
Whether ADD WIRE defaults layers' directions based on the preferred direction.

Wire.Refresh.On.DrawErase 
BOOLEAN - Default: true - NOVICE 
Whether the wire editing commands automatically refresh whenever you select a DRAW or ERASE command option.

Wire.SpVias.TrimMetal 
BOOLEAN - Default: false - NOVICE 
When true, ADD WIRE and MOVE WIRE generate special vias with trimmed metal for some special cases that connect to off-grid objects, to avoid violations with surrounding objects. When false, these vias are not trimmed and therefore create design rule violations.


Examples

DELETE WIRE (23400 34000) ;
DELETE WIRE (23400 34000) (23400 36000) ;
DELETE WIRE NET CLK_1


Related Commands

ADD WIRE adds or edits routing.

MOVE WIRE shifts wire segments laterally.

"

	<Type QHELP>
	<Header "Delete Wire Command Help">
<beginAutoGen "** Do not edit from here to the endAutoGen tag **" >
	<Tag DeleteWire
		<Toolname gsEnsemble>
		<Version 5.0>
		<Title "Delete Wire Form Help">
	>
<endAutoGen >
>
